#ifdef _USE_WXWIDGETS_
#ifndef __bbcreaMaracasVisuCutModule_h_INCLUDED__
#define __bbcreaMaracasVisuCutModule_h_INCLUDED__
#include "bbcreaMaracasVisu_EXPORT.h"
#include "bbtkWxBlackBox.h"
#include "CutModelMainPanel.h"

namespace bbcreaMaracasVisu
{

class bbcreaMaracasVisu_EXPORT CutModule
 : 
   public bbtk::WxBlackBox
{
	
  BBTK_BLACK_BOX_INTERFACE(CutModule,bbtk::WxBlackBox);
  BBTK_DECLARE_INPUT(In,vtkImageData*);
  BBTK_DECLARE_INPUT(Interactor,vtkRenderWindowInteractor*);
  BBTK_DECLARE_INPUT(Renderer,vtkRenderer*);
  BBTK_DECLARE_OUTPUT(Out,vtkImageData*);
  BBTK_PROCESS(Process);
  void Process();
  BBTK_CREATE_WIDGET(CreateWidget);
  void CreateWidget(wxWindow*);

private:
	CutModelMainPanel* _mainpanel;
	vtkImageData* _currentimage;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(CutModule,bbtk::WxBlackBox);
BBTK_NAME("CutModule");
BBTK_AUTHOR("car-prie@uniandes.edu.co");
BBTK_DESCRIPTION("extracts");
BBTK_CATEGORY("__CategoryBlackBox__");
BBTK_INPUT(CutModule,In,"Image",vtkImageData*,"");
BBTK_INPUT(CutModule,Interactor,"WindowInteractor",vtkRenderWindowInteractor*,"");
BBTK_INPUT(CutModule,Renderer,"Renderer",vtkRenderer*,"");
BBTK_OUTPUT(CutModule,Out,"Image output",vtkImageData*,"");
BBTK_END_DESCRIBE_BLACK_BOX(CutModule);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuCutModule_h_INCLUDED__
#endif // _USE_WXWIDGETS_

