#ifndef __bbcreaMaracasVisuSliceImage_h_INCLUDED__
#define __bbcreaMaracasVisuSliceImage_h_INCLUDED__
#include "bbcreaMaracasVisu_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include <vtkImageData.h>
#include <vtkImageReslice.h>

namespace bbcreaMaracasVisu
{

class bbcreaMaracasVisu_EXPORT SliceImage
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(SliceImage,bbtk::AtomicBlackBox);
  BBTK_DECLARE_INPUT(In,vtkImageData*);
  BBTK_DECLARE_INPUT(Z, double );
  BBTK_DECLARE_OUTPUT(Out,vtkImageData*);
  BBTK_PROCESS(Process);
  void Process();
	
	vtkImageReslice *imageReslice;
	
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(SliceImage,bbtk::AtomicBlackBox);
BBTK_NAME("SliceImage");
BBTK_AUTHOR("eduardo.davila@creatis.insa-lyon.fr");
BBTK_DESCRIPTION("filter");
BBTK_CATEGORY("");
BBTK_INPUT(SliceImage,In,"Input image",vtkImageData *,"");
BBTK_INPUT(SliceImage,Z,"Z",double,"");
BBTK_OUTPUT(SliceImage,Out,"Output image",vtkImageData *,"");
BBTK_END_DESCRIBE_BLACK_BOX(SliceImage);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuSliceImage_h_INCLUDED__

