#include "bbmaracasvisuSliderMinMax.h"
#include "bbcreaMaracasVisuPackage.h"


namespace bbcreaMaracasVisu
{

  //------------------------------------------------------------------------------------------------------------------------------------
  // Event handling auxiliar class
  //------------------------------------------------------------------------------------------------------------------------------------
 
	  //--------------------------------------------------------------------------------------------------------------------------------
	  // Constructors ans destructors
	  //--------------------------------------------------------------------------------------------------------------------------------
		wxWidgetSliderMinMax :: wxWidgetSliderMinMax(SliderMinMax *bbParent,mBarRange * modelBarRange)//(wxWindow *parent, mBarRange * modelBarRange)
		:wxEvtHandler()
		{			
			modBarRange = modelBarRange;
			mbbtkSliderMinMax = bbParent;
			modBarRange->PushEventHandler(this);
			Connect(modBarRange->GetId(),wxEVT_TSBAR,(wxObjectEventFunction) (wxCommandEventFunction) &wxWidgetSliderMinMax::onBarrange );
//			Connect(modBarRange->GetId(),98765,(wxObjectEventFunction) (wxCommandEventFunction)  &wxWidgetSliderMinMax::onActualChange_Bar );
			Connect(modBarRange->GetId(),wxEVT_TSBAR_ACTUAL,(wxObjectEventFunction) (wxCommandEventFunction)  &wxWidgetSliderMinMax::onActualChange_Bar );
			Connect(modBarRange->GetId(),wxEVT_TSBAR_START,(wxObjectEventFunction) (wxCommandEventFunction)  &wxWidgetSliderMinMax::onStartChange_Bar );		
			Connect(modBarRange->GetId(),wxEVT_TSBAR_END,(wxObjectEventFunction) (wxCommandEventFunction)  &wxWidgetSliderMinMax::onEndChange_Bar );
			Connect(modBarRange->GetId(),wxEVT_SELECTION_END,(wxObjectEventFunction) (wxCommandEventFunction)  &wxWidgetSliderMinMax::onSelectionEnd );
			Connect(modBarRange->GetId(),wxEVT_TSBAR_MOVED,(wxObjectEventFunction) (wxCommandEventFunction)  &wxWidgetSliderMinMax::onMovedBar );		
		}

		wxWidgetSliderMinMax ::  ~wxWidgetSliderMinMax()
		{
		}
		

	  //--------------------------------------------------------------------------------------------------------------------------------
	  // Min-Max Barrange received events
	  //--------------------------------------------------------------------------------------------------------------------------------
		void wxWidgetSliderMinMax :: onBarrange(wxCommandEvent& event)
		{
		}

		void wxWidgetSliderMinMax :: onActualChange_Bar(wxCommandEvent& event)
		{
			mbbtkSliderMinMax->bbSetOutputOutActual(modBarRange->GetActual());
			mbbtkSliderMinMax->bbSignalOutputModification(std::string("OutActual"));
		}

		void wxWidgetSliderMinMax :: onStartChange_Bar(wxCommandEvent& event)
		{
			mbbtkSliderMinMax->bbSetOutputOutStart(modBarRange->GetStart());
			mbbtkSliderMinMax->bbSignalOutputModification(std::string("OutStart"));
		}
		void wxWidgetSliderMinMax :: onEndChange_Bar(wxCommandEvent& event)
		{
			mbbtkSliderMinMax->bbSetOutputOutEnd(modBarRange->GetEnd());
			mbbtkSliderMinMax->bbSignalOutputModification(std::string("OutEnd"));
		}
		void wxWidgetSliderMinMax :: onSelectionEnd(wxCommandEvent& event)
		{
		}
		void wxWidgetSliderMinMax :: onMovedBar(wxCommandEvent& event)
		{
		}


  //--------------------------------------------------------------------------
  //-------------------------------------------------------------------------
  //--------------------------------------------------------------------------
  //--------------------------------------------------------------------------


BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,SliderMinMax)
BBTK_BLACK_BOX_IMPLEMENTATION(SliderMinMax,bbtk::WxBlackBox);

//------------------------------------------------------
void SliderMinMax::Process()
{
	if (mwxwidget!=NULL){
		bbSetOutputOutStart(mwxwidget->GetStart());
		bbSetOutputOutEnd(mwxwidget->GetEnd());
		bbSetOutputOutActual(mwxwidget->GetActual());
	} // mwxwidget
}

//------------------------------------------------------
void SliderMinMax::CreateWidget(wxWindow* parent)
{

    bbtkDebugMessageInc("Core",9,"SliderMinMax::CreateWidget()"<<std::endl);

		mwxwidget = new mBarRange(parent ,bbGetInputInW(), bbGetInputInH()); 
		mwxwidget -> SetOrientation( bbGetInputOrientation()==1 );
		mwxwidget -> setActiveStateTo(true);
		mwxwidget -> setVisibleLabels( bbGetInputShowLabels()==1 );
		mwxwidget -> setDeviceEndMargin(10);
   	    mwxwidget -> setRepresentedValues(bbGetInputInMin(), bbGetInputInMax());
		mwxwidget -> setDeviceBlitStart(10,10); 
		mwxwidget -> setIfWithActualDrawed(bbGetInputShowActual());
		mwxwidget -> SetStart(bbGetInputInMinShow());
		mwxwidget -> SetEnd(bbGetInputInMaxShow());  
		//wxWidgetSliderMinMax * eventHandler = new wxWidgetSliderMinMax(this, mwxwidget); //JPRx
		bbtkDebugDecTab("Core",9);

	bbSetOutputWidget( mwxwidget );


}

//------------------------------------------------------
void SliderMinMax::bbUserSetDefaultValues()
{
		mwxwidget = NULL;
		bbSetInputOrientation(1);
		bbSetInputInW(200);
		bbSetInputInH(65);
		bbSetInputInMax(200);
		bbSetInputInMin(1);
		bbSetInputInMaxShow(200);
		bbSetInputInMinShow(1);
		bbSetInputShowLabels(1);
		bbSetInputShowActual(true);

		bbSetOutputOutStart(0);
		bbSetOutputOutEnd(0);
		bbSetOutputOutActual(0);
}

		
	//-----------------------------------------------------------------	
	void SliderMinMax::bbUserInitializeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	void SliderMinMax::bbUserFinalizeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	

}
// EO namespace bbcreaMaracasVisu


