#ifndef CUTTINGMODELFIGURE_H_
#define CUTTINGMODELFIGURE_H_

#include "vtkTransform.h"
#include "vtkPolyData.h"

class CutModelFigure
{
public:
	CutModelFigure(){}	
	
	//~CutModelFigure();

	virtual void SetPosition(double x,double y, double z){
		_px = x;
		_py = y;
		_pz = z;
	}

	virtual void	SetScale(double sx,double sy, double sz){
		_sx = sx;
		_sy = sy;
		_sz = sz;
	}

	virtual void	SetRotation(double alfa,double beta, double teta){
        _alfa = alfa;
		_beta = beta;
		_teta = teta;
	}

	virtual void	SetSpacing(double spcX,double spcY, double spcZ){
		_spcX = spcX;
		_spcY = spcY;
		_spcZ = spcZ;
	}		

	virtual void SetVtkTransform(vtkTransform *transform){
		double *orient = transform->GetOrientation();
		_alfa = orient[0];
		_beta = orient[1];
		_teta = orient[2];

		double *scale = transform->GetScale();
		_sx = scale[0];
		_sy = scale[1];
		_sz = scale[2];

		double *position = transform->GetPosition();
		_px = position[0];
		_py = position[1];
		_pz = position[2];


	}
	virtual void SetInversVtkTransform(vtkTransform *inverstransform){
		_inversModel = inverstransform;
	}

	virtual bool IfPointInside(double x, double y, double z) = 0;
	virtual double	GetTheoricVolume()=0;	
	virtual vtkPolyData* getPolyData()=0;

private:
	double			_px;
	double			_py;
	double			_pz;
	double			_alfa;
	double			_beta;
	double			_teta;
	double			_spcX;
	double			_spcY;
	double			_spcZ;
	char *GetName;
protected:
	double			_sx;
	double			_sy;
	double			_sz;
	vtkTransform	*_inversModel;
	vtkTransform	*_matrixModel;	
};

#endif /*FIGURECUTTINGMODEL_H_*/
