
#include "CutModelFigureCube.h"

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
CutModelFigureCube::CutModelFigureCube()
: CutModelFigure()
{
	_vtkcube = vtkCubeSource::New();
	_vtkcube->SetXLength (1);
	_vtkcube->SetYLength (1);
	_vtkcube->SetZLength (1);
}
//----------------------------------------------------------------------------
CutModelFigureCube::~CutModelFigureCube()  // virtual
{
	_vtkcube->Delete();
}
//----------------------------------------------------------------------------
bool CutModelFigureCube::IfPointInside(double x, double y, double z) // virtual
{
	double in[4],out[4];
	in[0]=x;
	in[1]=y;
	in[2]=z;
	in[3]=1;
	_inversModel->MultiplyPoint (in, out);

	bool result=false;
	if ((out[0]>-0.5) && (out[0]<0.5) && (out[1]>-0.5) && (out[1]<0.5)  && (out[2]>-0.5) && (out[2]<0.5)  )
	{
		result=true;
	}
	return result;
}
//----------------------------------------------------------------------------
double CutModelFigureCube::GetTheoricVolume() // virtual
{
	return _sx * _sy * _sz;
}

//----------------------------------------------------------------------------
char *CutModelFigureCube::GetName() // virtual
{
	return "Cube";
}

vtkPolyData* CutModelFigureCube::getPolyData(){
    return _vtkcube->GetOutput();
}

