/*-----------------------------------------------------
  DEFINE
*------------------------------------------------------*/
#if !defined(__TOOLS_MARACAS_TOOLS_H__)
#define __TOOLS_MARACAS_TOOLS_H__

//#include "interface/wxWindows/widgets/wxManualSegmentation_MPRWidget.h"
/*-----------------------------------------------------
  INCLUDE
*------------------------------------------------------*/
#include <vector>

#include "wx/frame.h"
#include "wx/window.h"
#include "wx/event.h"

#include "osgi/impl/Framework.h"
#include "maracas/toolbox/IToolbox.h"
#include "maracas/toolbox/IClient.h"
#include "maracas/toolbox/IParameter.h"




class wxManualSegmentation_MPRWidget;




//using namespace std;
/*-----------------------------------------------------
Class MaracasTools

  Doc goes here.
	  
*------------------------------------------------------*/

class wxToolsHandler: public wxEvtHandler{
public:
	virtual void OnSelectToolEvent(wxCommandEvent& event)=0;
};



class MaracasTools: public wxToolsHandler, public IClient{
	public:
		static MaracasTools* GetInstance();
		wxFrame* GetToolbox(wxWindow* parent);
		IParameter* GetParameter(std::string name);
		void SetMPRWidget(wxManualSegmentation_MPRWidget* pWidget){widget = pWidget;}
		void OnSelectToolEvent(wxCommandEvent& event);
		
	protected:
		MaracasTools();
	private:
		static MaracasTools* INSTANCE;
		
		wxManualSegmentation_MPRWidget* widget;
		
		std::vector<int> ids;
		
		FILE* logger;
    	
		Framework* framework;
		IToolbox* toolbox;
		
		wxFrame* toolsFrame;
		wxFrame* optionsFrame;
		wxPanel* currentToolPanel;
		
		

		
		int GetIndexForButton(int _wxbuttonid);
		void SetIndexForButton(int _wxbuttonid);
};



#endif //__TOOLS_MARACAS_TOOLS_H__



