
#ifndef CONTOUR_VIEW_H
#define CONTOUR_VIEW_H

#include "vtkProperty.h"
#include "vtkActor.h"
#include "vtkPolyDataMapper.h"
#include "vtkPolyData.h"
#include "wxVtkBaseView.h"
#include <vector>

class ContourView  
{
public:
	ContourView();
	~ContourView();



	void	DeleteContours();
	void	SetWxVtkBaseView(wxVtkBaseView *wxvtkbaseview);
	void	Refresh();
	void	CreateNewContour(vtkPolyData *contour, int type);

private:

	enum ContourTypes
	{
		BLUE = 0,         /*!< Lumen Type. */  
		MAGENTA,              /*!< Wall Type. */ 
		GREEN,     /*!< Calcification Type. */  
		YELLOW          /*!< Hypodense Type. */
	};

	wxVtkBaseView					*_wxvtkbaseview;
	
	std::vector<vtkPolyDataMapper*> contour_mapped;
	std::vector<vtkActor*>			contour_actor;
	//vtkActor						*_contourVtkActor;
	//vtkPolyDataMapper				*_bboxMapper;

	void			DeleteVtkObjects();

	
};

#endif // ContourView


