#ifndef _PlaneDirectionViewer_H_
#define _PlaneDirectionViewer_H_

#include <math.h>

#include <iostream>
#include <vector>

#include <vtkRenderer.h>

#include <wx/wx.h>
#include "PlaneDirectionViewerPanel.h"
#include "PlaneDirectionManager.h"
#include "marTypes.h"

class  creaMaracasVisu_EXPORT PlaneDirectionViewer : public wxPanel  {

public:
	PlaneDirectionViewer(wxWindow* parent, int radio, double colour[3], int opacity);	
	~PlaneDirectionViewer();	

	void SetRenderer(vtkRenderer* render);
	void SetVectors( std::vector<double> lstPointsx, std::vector<double> lstPointsy, std::vector<double> lstPointsz);

	void UpdateDirections() throw (std::exception);

	static PlaneDirectionViewer* getInstance(wxWindow* parent,int radio, double colour[3], int opacity);

	static PlaneDirectionViewer* getInstance();
	
	void addRemoveActor(int index, bool addremove);

	void changeColor(int index,double r,double g,double b);

	void WriteInformation(std::string filename,double* spc=NULL);

	void SetArrowSize(int arrowsize);
private:
	static PlaneDirectionViewer* instance;
	PlaneDirectionManager* manager;
	std::vector<PlaneDirectionViewerPanel*> viewdata;
};

#endif /*PlanesOperations_H_*/
