


/**
 *  \file 
 *  \brief Class ThresholdImageView . 
 */

/**
 * \class ThresholdImageView
 * \brief 
 */
 
#ifndef __ThresholdImageView_h__
#define __ThresholdImageView_h__

#include <vtkImageReslice.h>
#include <vtkLookupTable.h>
#include <vtkImageMapToColors.h>
#include <vtkImageActor.h>
#include <vtkImageData.h>
#include "wxVtkBaseView.h"



class  ThresholdImageView 
  {
  public: 
	  ThresholdImageView( );
	  ~ThresholdImageView();
	  void onThreshold();
	  void onThresholdChange();
	  void onThresholdInterpolation(bool interpolate);
	  void onThresholdChangeOpacity (int opacity);
	  void onThresholdRemove();
	  
	  void SetImage(vtkImageData* image);
	  void SetwxVtkBaseView(wxVtkBaseView *baseview);
	  wxVtkBaseView *GetwxVtkBaseView();
	  void SetBaseColor(double r, double g, double b);
	  
	  void SetZ(int z);
	  void SetminMaxValue(int min, int max);
	  
  private:
	  int					_Z;
	  double				_baseColorR;
	  double				_baseColorG;
	  double				_baseColorB;
	  double				_minValue;
	  double				_maxValue;
	  bool					_actorPresent;
	  vtkImageData			*_image;
	  vtkImageReslice		*_imageReslicer;
	  vtkLookupTable		*_thresholdTable;
	  vtkImageMapToColors	*_thresholdMapper;
	  vtkImageActor			*_thresholdActor;
	  wxVtkBaseView			*_baseView;
  protected:
 };

#endif

