/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: vtk2DQuantSliceWidget.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:57 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#ifndef __VTK2DQUANTSLICEWIDGET__
#define __VTK2DQUANTSLICEWIDGET__

#include "wxImageViewerWidget.h"

#include <vtkActor.h>
#include <vtkPolyLine.h>
#include <vtkDataSetMapper.h>
#include <vtkPolyDataMapper.h>
#include <vtkUnstructuredGrid.h>


/**
 * \brief Class that brigde to VTK, override double click...
 */
class vtk2DQuantSliceWidget : public wxImageViewerWidget
{
public:

    vtk2DQuantSliceWidget( wxWindow* parent,
        wxWindowID id,
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = wxSUNKEN_BORDER, //wxTAB_TRAVERSAL,
        const wxString& name = wxPanelNameStr
        );
    ~vtk2DQuantSliceWidget( );

    //void SetContour( vtkUnstructuredGrid *cnt );
    void SetContour( vtkPolyData *cnt );
	void SetDiameterMin(vtkPoints *diameterMin, bool showActor);
	void SetDiameterMax(vtkPoints *diameterMax, bool showActor);
	void Show2DContourDiameters();
	void Hide2DContourDiameters();

protected:

private:

	// Contour
	vtkPolyData			*_cnt; 
	vtkPolyDataMapper	*_cntMapper;
	vtkActor			*_cntActor;

	// Diameter Min
	vtkActor			*_diameterMinvtkActor;
	vtkPolyLine			*_diameterMinvtkPolyLine;
	vtkDataSetMapper	*_diameterMinvtkDataSetMapper;
	vtkUnstructuredGrid *_diameterMinvtkUnstructuredGrid;

	// Diameter Max
	vtkActor			*_diameterMaxvtkActor;
	vtkPolyLine			*_diameterMaxvtkPolyLine;
	vtkDataSetMapper	*_diameterMaxvtkDataSetMapper;
	vtkUnstructuredGrid *_diameterMaxvtkUnstructuredGrid;


//  DECLARE_EVENT_TABLE( );

};

#endif //__VTK2DQUANTSLICEWIDGET__
