

#ifndef EMPTY_PANEL_WIDGET_H
#define EMPTY_PANEL_WIDGET_H



#include <vtkActor.h>
#include <vtkMarchingCubes.h>
#include <vtkPolyDataMapper.h>
#include <vtkImageData.h>



#include "wxVtkBaseView.h"
#include "wxVTKRenderWindowInteractor.h"
#include <kernel/axisExtractor02.h>

#include <wx/wx.h>
#include <wx/panel.h>

//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------

class wxEmptyPanelWidget: public wxPanel{
public:
	wxEmptyPanelWidget(wxWindow *parent);
	~wxEmptyPanelWidget();
	void ConfigureVTK(vtkImageData *imagedata, int x, int y, int z);
	void Refresh();
	void OnOpacity1(wxScrollEvent& event); // Original Volume
	void OnOpacity2(wxScrollEvent& event); // Result Volume
	void OnIsoValue(wxScrollEvent& event);
private:

	// Original Volume
	vtkMarchingCubes	*_mCubes;
	vtkPolyDataMapper	*_surfMapper;
	vtkActor			*_surfActor;

	// Result volume + Axis
	axisExtractor02		*_prgov;
	vtkPolyDataMapper	*_mapfinal;
	vtkActor			*_stripfinal;
	vtkPolyDataMapper	*_isoMapperMC6;
	vtkActor			*_isoActorMC6;
	vtkMarchingCubes	*_isoMC6;


	wxSlider			*_opacity1;
	wxSlider			*_opacity2;
	wxSlider			*_isoValue;
	wxVtk3DBaseView		*_imageviewer3D;
	wxPanel				*CreateControlPanel(wxWindow *parent);
	wxPanel				*CreateViewPanel(wxWindow *parent);
};

#endif // EMPTY_PANEL_WIDGET_H




