//------------------------------------------------------------------------------------------------------------
// Class definition include
//------------------------------------------------------------------------------------------------------------
#include "pColorPoint.h"

// -----------------------------------------------------------------------------------------------------------
// WX headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// -----------------------------------------------------------------------------------------------------------

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

//------------------------------------------------------------------------------------------------------------
// Class implementation
//------------------------------------------------------------------------------------------------------------

IMPLEMENT_CLASS(pColorPoint, wxObject)

//------------------------------------------------------------------------------------------------------------
// Constructors and destructors
//------------------------------------------------------------------------------------------------------------

/**
* Create a point of the function.
* @param x The x real value
* @param _color The asigned colour 
* @param isTemp The temporal o fixed asignation to the color
*/
pColorPoint :: pColorPoint(double  x , wxColour  col, bool isTemp)
{
	realX = x;
	colour = col;	
	isTemporal = isTemp;
}

pColorPoint :: ~pColorPoint()
{

}
//------------------------------------------------------------------------------------------------------------
// Methods implementation
//------------------------------------------------------------------------------------------------------------
/*
* Returns the x-value of the point
* @ realX
*/
double pColorPoint :: getRealX ()
{
	return realX;
}
/**
	* Returns the colour of the point
	* @retval colour
	*/
wxColor pColorPoint :: getColor ()
{
	return colour;
}

/**
* Indicates if the colour point is temporal or not
* @retval isTemporal
*/
bool pColorPoint :: isTemporalColor ()
{
	return isTemporal;
}


