//----------------------------------------------------------------------------
// Class definition include
//----------------------------------------------------------------------------
#include "pFunctionPoint.h"

// ----------------------------------------------------------------------------
// WX headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// ----------------------------------------------------------------------------

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

//----------------------------------------------------------------------------
// Class implementation
//----------------------------------------------------------------------------

IMPLEMENT_CLASS(pFunctionPoint, wxObject)

//----------------------------------------------------------------------------
// Constructors
//----------------------------------------------------------------------------
/**
* Create a point of the function.
* @param x The x value
* @param y The y value
*/
pFunctionPoint :: pFunctionPoint(int  x , int  y ) 
{
	realX = x;
	realY = y;
	hasColorForLevel = false;
}
//----------------------------------------------------------------------------
// Methods
//----------------------------------------------------------------------------
/*
* Returns the x-value of the point
* @ realX
*/
int pFunctionPoint ::getRealX ()
{
	return realX;
}
/**
* Returns the x-value of the point
* @ realY
*/
int pFunctionPoint :: getRealY ()
{
	return realY;
}
/*
* Sets the state of having an asigned color
*/
void  pFunctionPoint :: setHasColor (bool hasColor)
{
	hasColorForLevel = hasColor;
}
/*
* Indicates if the point has an asigned color for the level 
*/
bool  pFunctionPoint :: getHasColorForLevel()
{
	return hasColorForLevel;
}


