#ifndef __pFunctionPoint_h__
#define __pFunctionPoint_h__

// ----------------------------------------------------------------------------
// WX headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// ----------------------------------------------------------------------------

#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif


//----------------------------------------------------------------------------
// Includes
//----------------------------------------------------------------------------


//----------------------------------------------------------------------------
// Class definition
//----------------------------------------------------------------------------

class pFunctionPoint : public wxObject {

	//----------------------------------------------------------------------------
	// Methods definition
	//----------------------------------------------------------------------------
public:
	/**
	* Create a point of the function.
	* @param x The x value
	* @param y The y value
	*/
	pFunctionPoint(int  x , int  y ) ;

	/*
	* Returns the x-value of the point
	* @ realX
	*/
	int getRealX ();
	/**
	* Returns the y-value of the point
	* @ realY
	*/
	int getRealY ();
	/**
	* Sets the x-value of the point
	* @param x
	*/
	void setRealX(int x)
	{
		realX=x;
	}
	/**
	* Sets the y-value of the point
	* @param y
	*/	
	void setRealY(int y)
	{
		realY=y;
	}
	/*
	* Sets the state of having an asigned color
	*/
	void setHasColor (bool hasColor);
	/*
	* Indicates if the point has an asigned color for the level 
	*/
	bool getHasColorForLevel();


	//----------------------------------------------------------------------------
	// Attributes declration
	//----------------------------------------------------------------------------

private:
	/*
	* The x-value of the point
	*/
	int realX;
	/*
	* The y-value of the point
	*/          
	int realY;
	/*
	*  Indicates if the point has an asigned color for the level
	*/
	bool hasColorForLevel;

	DECLARE_CLASS (pFunctionPoint)
};

#endif


