#include "wxMaracasDialog_NViewers.h"
//#include <wx/frame.h> 
#include <wx/sizer.h> 
#include <wx/splitter.h>
#include "creaSystem.h"

BEGIN_EVENT_TABLE( wxMaracasDialog_NViewers, wxFrame )
	EVT_MENU( 12121, wxMaracasDialog_NViewers::OnRefreshView )
	EVT_MENU( 12122, wxMaracasDialog_NViewers::OnDClickLeft )
END_EVENT_TABLE( );

/**
** Class constructor
**/
wxMaracasDialog_NViewers::wxMaracasDialog_NViewers(wxWindow* parent, vtkImageData* img, std::vector<int>* type, wxString title)
//: wxFrame(parent, -1, title)
: wxFrame(NULL, -1, title, wxDefaultPosition,wxSize(700,700))
{

	wxSplitterWindow *splitpanel = new wxSplitterWindow(this, -1);
	splitpanel->SetMinimumPaneSize(5);

	viewer = new wxMaracas_N_ViewersWidget(splitpanel, img, type);

	std::string path = crea::System::GetDllAppPath("bbcreaMaracasVisu.dll");
	cutter = CutModelMainPanel::getInstance(splitpanel, path);
	cutter->setRenderer( viewer->GetwxVtkBaseView(1)->GetRenderer() );
	cutter->setInteractor( viewer->GetwxVtkBaseView(1)->GetWxVTKRenderWindowInteractor() );
	cutter->setImageData(img);
	
	splitpanel->SplitVertically( cutter, viewer, 50);

}

/**
** Class destructor
**/
wxMaracasDialog_NViewers::~wxMaracasDialog_NViewers(){	
}


/**
**
**/
void wxMaracasDialog_NViewers::OnRefreshView(wxCommandEvent & event)
{
	point.clear();
	point.push_back((int)viewer->GetX());
	point.push_back((int)viewer->GetY());
	point.push_back((int)viewer->GetZ());

	viewer->OnRefreshView(event);
}

/**
**
**/
void wxMaracasDialog_NViewers::OnDClickLeft(wxCommandEvent & event)
{
	viewer->OnDClickLeft(event);
}

/**
**
**/
wxMaracas_N_ViewersWidget* wxMaracasDialog_NViewers::getViewer()
{
	return viewer;
}