#ifndef __wxMaracasSuperpositionPanelH__
#define __wxMaracasSuperpositionPanelH__

// -----------------------------------------------------------------------------------------------------------
// WX headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// -----------------------------------------------------------------------------------------------------------

#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <wx/scrolwin.h>

//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------

#include "wxMaracas_N_ViewersWidget.h"
#include "vtkImageData.h"
#include "wxVtkBaseView.h"

//------------------------------------------------------------------------------------------------------------
// Class definition
//------------------------------------------------------------------------------------------------------------

class creaMaracasVisu_EXPORT wxMaracasSuperpositionPanel : public wxPanel
{

public:

	wxMaracasSuperpositionPanel( std::vector<vtkImageData*> imgs, int type, wxWindow *parent, const wxPoint& pos=wxDefaultPosition, 
	const wxSize& size = wxDefaultSize,long style= wxDEFAULT_FRAME_STYLE | wxSUNKEN_BORDER, int vertStart=1, int vertEnd=1, 
	int horzStart=1, int horzEnd=1 );


	~wxMaracasSuperpositionPanel();	

//------------------------------------------------------------------------------------------------------------
// Creational and initialization methods
//------------------------------------------------------------------------------------------------------------
	
	void createSuperpositionPanel();

//------------------------------------------------------------------------------------------------------------
//  Other functional methods
//------------------------------------------------------------------------------------------------------------

	void getSpacing( double * spacing );

	wxVtkBaseView* GetWxVtkBaseView();
	wxVtkMPR2DView * GetwxVtkMPR2DView();
	vtkImageData * GetshowingVID();
	int GetImageDataSizeZ();
	void RefreshInterface();
	void ChangeImage(vtkImageData* img);
	
	void	SetVisibleAxis(bool ok);
	int		GetX();
	int		GetY();
	int		GetZ();
	void	Refresh();	
	

private:

	std::vector<vtkImageData*> _images;
	
	
	int _type;
	
	/*
	* Represents the panel for viewing
	*/
	wxMaracas_N_ViewersWidget * theViewPanel;
	
	/*
	* Represents the outer sizer of the IRMViewPanel
	*/
	wxFlexGridSizer* outSizer;

	double last_spacing[3];
	
};

#endif /*__wxMaracasSuperpositionPanelH__*/
