/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracas_ViewerWidget.h,v $
  Language:  C++
  Date:      $Date: 2009/09/15 11:25:07 $
  Version:   $Revision: 1.8 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __WX__MARACAS__VIEWERWIDGET__H__
#define __WX__MARACAS__VIEWERWIDGET__H__


// -----------------------------------------------------------------------------------------------------------
// WX headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// -----------------------------------------------------------------------------------------------------------
#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------

#include "vtkImageData.h"
#include "vtkRenderer.h"

#include "wxVtkBaseView.h"
#include "wxMPRWidget.h"

//------------------------------------------------------------------------------------------------------------
// Class definition
//------------------------------------------------------------------------------------------------------------


 class wxMaracas_ViewerWidget : public wxPanel
  {
  public:
	  
	//------------------------------------------------------------------------------------------------------------
	// Constructors & Destructors
	//------------------------------------------------------------------------------------------------------------

    wxMaracas_ViewerWidget(wxWindow *parent, vtkImageData* imagedata, int type, vtkMPRBaseData *vtkmprbasedata=NULL);
    ~wxMaracas_ViewerWidget();

	//------------------------------------------------------------------------------------------------------------
	// Methods
	//------------------------------------------------------------------------------------------------------------

//    vtkRenderer *GetRenderer();
	void ConfigureVTK();
	void RefreshView();
	virtual void Refresh(bool eraseBackground = true,const wxRect* rect = NULL );

	wxVtkBaseView *GetwxVtkBaseView();
	void SetImage( vtkImageData *image	);
	double GetX();
	double GetY();
	double GetZ();

	//------------------------------------------------------------------------------------------------------------
	// Attributes
	//------------------------------------------------------------------------------------------------------------

	void setColorTransferFunction(vtkColorTransferFunction* colortable);

	void setWindowLevel(double level);

	void setColorLevel(double level);
  private:
		int								mType;

		bool                            minternalVtkmprbasedata;
		vtkMPRBaseData					*mvtkmprbasedata; 

		wxVtk2DBaseView					*mvtk2Dbaseview;
		wxVtkMPR2DView					*mvtkmpr2Dview_X; 
		wxVtkMPR2DView					*mvtkmpr2Dview_Y; 
		wxVtkMPR2DView					*mvtkmpr2Dview_Z; 
		wxWidgetMesure2D_Plane_in_MPR	*mwidgetMesure;
		vtkPlane2DView					*mvtkplane2Dview;
		wxSphereView					*mwxsphereview; 

		wxVtkClipping3DView				*mwxvtkclipping3Dview;
		wxVtk3DBaseView					*mwxvtk3Dbaseview_Clipping3D;
		wxVtkMPR3DView					*mwxvtkmpr3Dview;


		vtkMPR3DDataViewer				*vtkmpr3Ddataviewer;


  };

#endif // __WX__MARACAS__VIEWERWIDGET__H__
