#include "wxVtkMPR3DView.h"

#include "vtkDataSetMapper.h"
#include "vtkPlaneSource.h"
#include "vtkProbeFilter.h"
#include "vtkStructuredPoints.h"
#include "vtkMetaImageWriter.h"
#include "vtkDataSetMapper.h"
#include "vtkImageChangeInformation.h"
#include "vtkPointData.h"
#include "vtkWindowLevelLookupTable.h"
#include "vtkPlane.h"
#include "vtkCutter.h"
#include "vtkTransform.h"
#include "vtkmyPWCallback_3DPointWidget.h"

wxVtkMPR3DView::wxVtkMPR3DView( wxVtk3DBaseView *wxvtk3Dbaseview )
{
	_wxvtk3Dbaseview			=	wxvtk3Dbaseview;
	_vtkmpr3Ddataviewer			=	NULL;
	_wxvtkmpr3DviewCntrlPanel	=	NULL;	
	//_myCallback=NULL;
	_pointWidget=NULL;
	_planeWidget=NULL;
	_vtkplane=NULL;
	_probe=NULL;
	_contourMapper=NULL;
}
void wxVtkMPR3DView::RemoveActor(vtkActor* actor){	

	_wxvtk3Dbaseview->GetRenderer()->RemoveActor(actor);	


}
void wxVtkMPR3DView::ResetCamera(int* ext, double* origin,double* spc){
	if(ext == NULL){

		_wxvtk3Dbaseview->GetRenderer()->ResetCamera ();	
		_wxvtk3Dbaseview->GetCamera()->Dolly(1.5);	
	}else{
		/*double x = (spc[0])*(origin[0]+(((double)ext[1]-(double)ext[0])/2.0));		
		double y = (spc[1])*(origin[1]+(double)ext[3]);
		double z = (spc[2])*(origin[2]+(((double)ext[5]-(double)ext[4])/2.0));*/
		/*double x0=(spc[0])*((double)ext[0]+origin[0]);
		double x1=(spc[0])*((double)ext[1]+origin[0]);
		double y0=(spc[1])*((double)ext[2]+origin[1]);
		double y1=(spc[1])*((double)ext[3]+origin[1]);
		double z0=(spc[2])*((double)ext[4]+origin[2]);
		double z1=(spc[2])*((double)ext[5]+origin[2]);*/
		double x0=(spc[0])*((double)ext[0]);
		double x1=(spc[0])*((double)ext[1]);
		double y0=(spc[1])*((double)ext[2]);
		double y1=(spc[1])*((double)ext[3]);
		double z0=(spc[2])*((double)ext[4]);
		double z1=(spc[2])*((double)ext[5]);
		
		_wxvtk3Dbaseview->GetRenderer()->ResetCamera(x0,x1,y0,y1,z0,z1);
		//_wxvtk3Dbaseview->GetCamera()->SetPosition(x,y,z);
		_wxvtk3Dbaseview->GetCamera()->Dolly(1.5);	
	}
}
void wxVtkMPR3DView::Configure(){


	_wxvtk3Dbaseview->Configure();
	_wxvtkmpr3DviewCntrlPanel->UpdateControlPanel();
	
//EED 27 Mai 2009 
//	_wxvtk3Dbaseview->GetRenderer()->Clear();    
	
	// Actors are added to the renderer. 
	vtkActor* _outlineActor = _vtkmpr3Ddataviewer->GetOutlineActor();
	_wxvtk3Dbaseview->GetRenderer()->AddActor( _outlineActor );			
//	_wxvtk3Dbaseview->GetRenderer()->AddActor( _vtkmpr3Ddataviewer->GetImageActor(0)  );	// _saggital
//	_wxvtk3Dbaseview->GetRenderer()->AddActor( _vtkmpr3Ddataviewer->GetImageActor(1)  );	// _axial
//	_wxvtk3Dbaseview->GetRenderer()->AddActor( _vtkmpr3Ddataviewer->GetImageActor(2)  );	// _coronal


	// An initial camera view is created.  The Dolly() method moves 
	// the camera towards the FocalPoint, thereby enlarging the image.	
	_wxvtk3Dbaseview->GetRenderer()->SetActiveCamera(_wxvtk3Dbaseview->GetCamera());
	this->ResetCamera();
	

	// Set a background color for the renderer and set the size of the
	// render window (expressed in pixels).
	_wxvtk3Dbaseview->GetRenderer()->SetBackground( 0.36 , 0.36 , 0.36 );
	_wxvtk3Dbaseview->GetRenWin()->SetSize(400, 400);

	// Note that when camera movement occurs (as it does in the Dolly()
	// method), the clipping planes often need adjusting. Clipping planes
	// consist of two planes: near and far along the view direction. The 
	// near plane clips out objects in front of the plane; the far plane
	// clips out objects behind the plane. This way only what is drawn
	// between the planes is actually rendered.
	_wxvtk3Dbaseview->GetRenderer()->ResetCameraClippingRange();


	// vtkPointWidget
	//if(_myCallback!=NULL){
		//_myCallback->Delete();

	//}
	vtkmyPWCallback_3DPointWidget *_myCallback = vtkmyPWCallback_3DPointWidget::New();
	_myCallback->SetWxVtkMPR3DView(this);
 
	if(_pointWidget!=NULL){
		_pointWidget->Delete();
	}
	_pointWidget = vtkPointWidget::New();
	_myCallback->SetVtkPointWidget(_pointWidget);
	_pointWidget->SetInteractor( GetWxvtk3Dbaseview()->GetWxVTKRenderWindowInteractor() ); 
	_pointWidget->SetInput( GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetImageData() );
	
	_pointWidget->AllOff();
	
	_pointWidget->PlaceWidget();
//	_pointWidget->SetPosition( x,y,z ); 
	
//EED01 29Mars2009
// MACOS probleme vtk-window out of wx-window 	
//	_pointWidget->On();
	
	_pointWidget->AddObserver(vtkCommand::InteractionEvent,_myCallback);


// PlaneWidget
	if(_planeWidget!=NULL){
		_planeWidget->Delete();
	}
	_planeWidget = vtkPlaneWidget::New();
	_myCallback->SetVtkPlaneWidget(_planeWidget);
	_planeWidget->SetInput( GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetImageData() );
	_planeWidget->NormalToXAxisOn();
	_planeWidget->SetResolution(50);
	_planeWidget->SetRepresentationToOutline();
	int dim[3];
	GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetImageData()->GetDimensions(dim);
	int px=(dim[0]/2);
	int py=(dim[1]/2);
	int pz=(dim[2]/2);
	int dd=20;
	_planeWidget->PlaceWidget( px-dd , px+dd , py-dd , py+dd , pz-dd , pz+dd );


	if(_vtkplane==NULL){
		_vtkplane = vtkPolyData::New();
		
		_probe = vtkProbeFilter::New();
		_probe->SetInput(_vtkplane);

		_contourMapper = vtkPolyDataMapper::New();
		
		_contourMapper->SetInput( _probe->GetPolyDataOutput() );

		_contourPlaneActor = vtkActor::New();
		_contourPlaneActor->SetMapper(_contourMapper);

		_contourPlaneActor->VisibilityOff();

		_planeWidget->SetInteractor( GetWxvtk3Dbaseview()->GetWxVTKRenderWindowInteractor() );
		_planeWidget->AddObserver(vtkCommand::InteractionEvent,_myCallback);

		_planeWidget->Off();
		_wxvtk3Dbaseview->GetRenderer()->AddActor( _contourPlaneActor );	

	}else{
		
	}
	_planeWidget->GetPolyData(_vtkplane);

	
	vtkImageData *imageData = GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetImageData();	
	_probe->SetSource( imageData );

	
	_contourMapper->SetScalarRange( imageData->GetScalarRange() );
    
	

			
}
//-------------------------------------------------------------------
wxVtkMPR3DView::~wxVtkMPR3DView()
{
	VisiblePointWidget( false );
	VisiblePlaneWidget( false );
	
	if(_pointWidget!=NULL){
		_pointWidget->Delete();
	}
	if(_planeWidget!=NULL){
		_planeWidget->Delete();
	}

	if(_vtkplane!=NULL){
		_vtkplane->Delete();		
		_probe->Delete();
		_contourMapper->Delete();			
		_contourPlaneActor->Delete();		
	}

}
void wxVtkMPR3DView::setColorTransferFunction(vtkColorTransferFunction* colortable){
	GetVtkMPR3DDataViewer ()->setColorTransferFunction(colortable);	
}
//-------------------------------------------------------------------
void wxVtkMPR3DView::Refresh()   // virtual
{
	_vtkmpr3Ddataviewer	->	Refresh();
	if (_wxvtkmpr3DviewCntrlPanel!=NULL)
	{
		_wxvtkmpr3DviewCntrlPanel->Refresh();
	}

}
//-------------------------------------------------------------------
void wxVtkMPR3DView::RefreshView()   // virtual
{
	double spc[3];
	this->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetImageData()->GetSpacing(spc);

	//double nx=1,ny=0,nz=0; // JPRx
	Refresh();
	double x=GetVtkMPR3DDataViewer ()->GetVtkMPRBaseData()->GetX();
	double y=GetVtkMPR3DDataViewer ()->GetVtkMPRBaseData()->GetY();
	double z=GetVtkMPR3DDataViewer ()->GetVtkMPRBaseData()->GetZ();

	x=x*spc[0];
	y=y*spc[1];
	z=z*spc[2];

	_pointWidget->SetPosition( x,y,z ); 


	double in[3]; 
	double normal[3];
	vtkTransform *transform = GetVtkMPR3DDataViewer ()->GetVtkMPRBaseData()->GetTransformOrientation();
	in[0]=1;		in[1]=0;			in[2]=0;
	transform->TransformPoint(in,normal);
	_planeWidget->SetNormal( normal[0],normal[1],normal[2] );


	_planeWidget->SetCenter( x,y,z );
	_planeWidget->UpdatePlacement();
	_planeWidget->GetPolyData(_vtkplane);
}
//-------------------------------------------------------------------
wxPanel* wxVtkMPR3DView::CreateControlPanel(wxWindow *parent, bool align)
{
	_wxvtkmpr3DviewCntrlPanel = new wxVtkMPR3DViewCntrlPanel(parent,this, align);
	return _wxvtkmpr3DviewCntrlPanel;
}
//-------------------------------------------------------------------
vtkMPR3DDataViewer* wxVtkMPR3DView::GetVtkMPR3DDataViewer() 
{
	return _vtkmpr3Ddataviewer; 
}
//-------------------------------------------------------------------
wxVtk3DBaseView* wxVtkMPR3DView::GetWxvtk3Dbaseview() throw (char*)
{
	if(_wxvtk3Dbaseview==NULL){
		throw "wxVtk3DBaseView* wxVtkMPR3DView::GetWxvtk3Dbaseview() _wxvtk3Dbaseview=NULL";
	}
	return _wxvtk3Dbaseview;
}
//-------------------------------------------------------------------

//-------------------------------------------------------------------
void wxVtkMPR3DView::VisibleImageActor(int idPosition, bool visible){
	/*if(visible == false)
		printf("CPR: wxVtkMPR3DView::VisibleImageActor-> visibleActor == false \n");
	else
	{
		printf("CPR: wxVtkMPR3DView::VisibleImageActor-> visibleActor == true\n");
		printf("CPR: wxVtkMPR3DView::VisibleImageActor-> idPosition == %d\n", idPosition);
	}
	*/
	if (visible!=_vtkmpr3Ddataviewer->GetVisiblePosition(idPosition)){
		if (visible==false){
			_wxvtk3Dbaseview->GetRenderer()->RemoveActor( _vtkmpr3Ddataviewer->GetImageActor(idPosition)  );	
		} else {
			_wxvtk3Dbaseview->GetRenderer()->AddActor( _vtkmpr3Ddataviewer->GetImageActor(idPosition)  );	
		}
		_vtkmpr3Ddataviewer->SetVisiblePosition(idPosition,visible);
	}
}


//-------------------------------------------------------------------
void wxVtkMPR3DView::VisiblePointWidget( bool visible )
{
	if (visible==true)
	{
		_pointWidget->On();
	} else {
		_pointWidget->Off();
	}
}

//-------------------------------------------------------------------
void wxVtkMPR3DView::VisiblePlaneWidget( bool visible )
{
	if (visible==true)
	{
		_planeWidget->On();
		_contourPlaneActor->VisibilityOn();

	} else {
		_planeWidget->Off();
		_contourPlaneActor->VisibilityOff();
	}
}

//CPR: Method added 30 Nov 2009
void wxVtkMPR3DView::showOutlineActor(bool value)
{
	vtkActor* _outlineActor = _vtkmpr3Ddataviewer->GetOutlineActor();
	if(value == true)
	{
		_wxvtk3Dbaseview->GetRenderer()->AddActor( _outlineActor );	
	}
	else
	{
		_wxvtk3Dbaseview->GetRenderer()->RemoveActor( _outlineActor );	
	}
}

//-------------------------------------------------------------------
void wxVtkMPR3DView::SetVtkMPR3DDataViewer(vtkMPR3DDataViewer *vtkmpr3Ddataviewer)
{
	_vtkmpr3Ddataviewer = vtkmpr3Ddataviewer;
}

//-------------------------------------------------------------------
void wxVtkMPR3DView::InitOrientationPointWidget()
{
	this->_planeWidget->SetNormal(1,0,0);   	
}




//-------------------------------------------------------------------
// EED 25 Janvier 2007 testLoic
void wxVtkMPR3DView::TestLoic1()
{

	int sizeIma	= 128;
  double dimIma = sizeIma*2;

	vtkImageData *vtkimagedata =  this->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetImageData();

	double spc[3];
	vtkimagedata->GetSpacing(spc);

	vtkimagedata->Update();


	 double p[3], n[3];
     this->_planeWidget->GetOrigin(p);
     this->_planeWidget->GetNormal(n);



    vtkPlaneSource* pSource = vtkPlaneSource::New( );
    pSource->SetResolution( sizeIma - 1, sizeIma - 1 );
    pSource->SetOrigin( p[ 0 ], p[ 1 ], p[ 2 ] );
    pSource->SetPoint1( p[ 0 ] + dimIma - 1.0, p[ 1 ], p[ 2 ] );
    pSource->SetPoint2( p[ 0 ], p[ 1 ]+ dimIma - 1.0 , p[ 2 ] );
    pSource->Update( );
    pSource->SetCenter( p[ 0 ], p[ 1 ], p[ 2 ] );
    pSource->SetNormal( n[ 0 ], n[ 1 ], n[ 2 ] );
    pSource->Update( );

    vtkProbeFilter* slices = vtkProbeFilter::New();
    slices->SetInput( ( vtkDataSet* )pSource->GetOutput( ) );
    slices->SetSource( vtkimagedata );
    slices->Update( );
    pSource->Delete( );

	vtkStructuredPoints   *stPoints = vtkStructuredPoints::New();
	stPoints -> GetPointData( )->SetScalars(  slices->GetOutput()->GetPointData()->GetScalars()  );
	stPoints -> SetDimensions( sizeIma, sizeIma, 1 );
	stPoints -> SetScalarType( vtkimagedata->GetScalarType() );
	stPoints -> SetScalarTypeToShort();
	stPoints -> Update();

	vtkImageChangeInformation  *change = vtkImageChangeInformation ::New();
	change	  -> SetInput( stPoints );  
	change	  -> Update();    //important

	double _range[2];
	vtkimagedata->GetScalarRange(_range);
   vtkWindowLevelLookupTable *_bwlookup = vtkWindowLevelLookupTable::New( );
   _bwlookup->SetHueRange( 0 , 1 );
   _bwlookup->SetNumberOfColors( (int)(_range[1] - _range[0] + 1) );
   _bwlookup->SetTableRange( _range[0] , _range[1] );
   _bwlookup->SetSaturationRange( 0 , 0 );
   _bwlookup->SetValueRange( 0 , 1 );
   _bwlookup->SetAlphaRange( 1 , 1 );
   _bwlookup->Build( );
 
   vtkLookupTable * _collookup = vtkLookupTable::New( );
   _collookup->SetNumberOfColors( 256 );
   _collookup->SetTableRange( 0 , 255 );
   _collookup->Build( );
   _collookup->SetTableValue( 0  , 1 , 0 , 0 , 1 );
   _collookup->SetTableValue(128 , 0 , 0 , 1 , 1 );
   _collookup->SetTableValue(255 , 0 , 1 , 0 , 1 );


	vtkMetaImageWriter *writer = vtkMetaImageWriter::New( );
	writer->SetInput( stPoints );
	writer->SetFileName( "C:/Users/Images/temp_EED/image.mhd" );
	writer->SetFileDimensionality( 2 );
	writer->Write( );



	vtkDataSetMapper *_3DSliceMapper = vtkDataSetMapper::New( );
	_3DSliceMapper->SetInput(change->GetOutput( ) );
	_3DSliceMapper->SetLookupTable( _bwlookup );
	_3DSliceMapper->SetScalarRange( _range );
	_3DSliceMapper->ImmediateModeRenderingOn( );

	vtkActor *_3DSliceActor = vtkActor::New( );
	_3DSliceActor->SetMapper( _3DSliceMapper );

 // The usual rendering stuff.
  vtkCamera *camera = vtkCamera::New();
      camera->SetPosition(1,1,1);
      camera->SetFocalPoint(0,0,0);

  vtkRenderer *renderer = vtkRenderer::New();
  vtkRenderWindow *renWin = vtkRenderWindow::New();
    renWin->AddRenderer(renderer);

  vtkRenderWindowInteractor *iren = vtkRenderWindowInteractor::New();
    iren->SetRenderWindow(renWin);

  renderer->AddActor( _3DSliceActor );
      renderer->SetActiveCamera(camera);
      renderer->ResetCamera();
      renderer->SetBackground(1,1,1);
  
  renWin->SetSize(300,300);

  // interact with data
  renWin->Render();
  iren->Start();





}

//-------------------------------------------------------------------
// EED 25 Janvier 2007 testLoic
void wxVtkMPR3DView::TestLoic2()
{
/*
 vtkVectorNorm *vecMagnitude = vtkVectorNorm::New();
                vecMagnitude->SetInput(VtkMainGrid);
                vecMagnitude->NormalizeOff();
                vecMagnitude->Update();
*/

        vtkPlane *slicePlane = vtkPlane::New();
				this->_planeWidget->GetPlane( slicePlane );

                
        vtkCutter* sliceCutter = vtkCutter::New();
		vtkImageData *vtkimagedata =  this->GetVtkMPR3DDataViewer()->GetVtkMPRBaseData()->GetImageData();
                sliceCutter->SetInput( vtkimagedata );
                sliceCutter->SetCutFunction( slicePlane );

//EED
//        vtkLookupTable *lut = BuildHueWeightBaseMap();


        vtkPolyDataMapper *slice = vtkPolyDataMapper::New();
                slice->SetInput( sliceCutter->GetOutput() );
        double range[2];
// EED
//                slice->Update();
				  vtkimagedata->GetScalarRange(range);
//                vecMagnitude->GetOutput()->GetScalarRange( range );
//                range[1] *= 0.7; // reduce the upper range by 30%
//                slice->SetScalarRange( range );
//                slice->SetLookupTable( lut );

//       vtkActor *sliceActor = vtkActor::New();
//                sliceActor->SetMapper( slice );

        vtkPolyDataMapper *contourMapper = vtkPolyDataMapper::New();
                contourMapper->SetInput( sliceCutter->GetOutput() );
                contourMapper->SetScalarRange( range );
  //              contourMapper->SetLookupTable( lut );

                
        vtkActor *contourActor = vtkActor::New();
                contourActor->SetMapper( contourMapper );



 // The usual rendering stuff.
  vtkCamera *camera = vtkCamera::New();
      camera->SetPosition(1,1,1);
      camera->SetFocalPoint(0,0,0);

  vtkRenderer *renderer = vtkRenderer::New();
  vtkRenderWindow *renWin = vtkRenderWindow::New();
    renWin->AddRenderer(renderer);

  vtkRenderWindowInteractor *iren = vtkRenderWindowInteractor::New();
    iren->SetRenderWindow(renWin);

  renderer->AddActor( contourActor );
//  renderer->AddActor(cubeActor);
      renderer->SetActiveCamera(camera);
      renderer->ResetCamera();
      renderer->SetBackground(1,1,1);
  
  renWin->SetSize(300,300);

  // interact with data
  renWin->Render();
  iren->Start();


}

