/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasMPR.cxx,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:31 $
  Version:   $Revision: 1.4 $

  Copyright: (c) 2002, 2003
  License:

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#include "wxMaracasMPR.h"


wxMaracasMPR::wxMaracasMPR( wxWindow* parent,
                            marImageData* marimagedata , double voxelSize)
: wxPanel( parent, -1, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL)
{
	_MPR=NULL;
	wxBoxSizer* szTop = new wxBoxSizer( wxVERTICAL );
	_MPR = new wxMPRWidget( this, marimagedata , voxelSize);
	szTop->Add( _MPR, 1  , wxGROW |  wxALL , 0 );
	this->SetAutoLayout( true );
	this->SetSizer( szTop );
	szTop->Fit( this );
//	szTop->SetSizeHints( this );
}
//----------------------------------------------------------------------------
wxMaracasMPR::~wxMaracasMPR( )
{
	if (_MPR!=NULL) { delete _MPR; }
}
//----------------------------------------------------------------------------
void wxMaracasMPR::ConfigureVTK( )
{
	if (_MPR!=NULL ) {_MPR->ConfigureVTK(); }
}
//----------------------------------------------------------------------------
vtkMPRBaseData  *wxMaracasMPR::GetVtkMPRBaseData()
{
	return _MPR->GetVtkMPRBaseData();
}
//----------------------------------------------------------------------------
vtkPlane2DView *wxMaracasMPR::GetVtkPlane2DView()
{
	return _MPR->GetVtkPlane2DView();
}
//----------------------------------------------------------------------------
wxVtkMPR3DView  *wxMaracasMPR::GetWxvtkmpr3Dview_BB() throw(char*)
{ 
	if(_MPR == NULL){ 
        throw "wxVtkMPR3DView  *wxMaracasMPR::GetWxvtkmpr3Dview_BB() _MPR =NULL";
	}
	if(_MPR->GetWxvtkmpr3Dview_BB() ==NULL){
		throw "wxVtkMPR3DView  *wxMaracasMPR::GetWxvtkmpr3Dview_BB() _MPR->GetWxvtkmpr3Dview_BB()=NULL";
	}
	return _MPR->GetWxvtkmpr3Dview_BB();
}

//----------------------------------------------------------------------------
void wxMaracasMPR::RefreshView()
{ 
	_MPR->RefreshView();
}

void wxMaracasMPR::setImageData(vtkImageData *img, double voxelsize){
	_MPR->setImageData(img, voxelsize);

}

// EOF - wxMaracasMPR.cxx




