#include "vtkImageData.h"
/**
* Clase para segmentar una imagen usando fast marching
*
* La imagen de velocidad se obtiene aplicando una transformacion sigmoide a cada voxel.
* Dicha transformacion esta regida por los parmetros alfa (pendiente) y beta(centro de pivotaje)
*/

class itkFM3D
{
public:
	itkFM3D();
	virtual ~itkFM3D();
	void AddSeed(int x, int y, int z);
	void SetAlpha(double alpha);
	void SetBeta(double beta);
	void SetStopTime(double stopTime);
	void CurvatureAnisotropicFiltertOn();
	void CurvatureAnisotropicFilterOff();
	vtkImageData* segment(vtkImageData *volume);
	double GetEstimatedOtsuTreshold();
	
protected:

	 FILE *logger;

private:
	double alpha;
	double beta;
	double stopTime;
	int usefilter;
	int x;
	int y;
	int z;
	double estimatedOtsuThreshold;
};
