/*=========================================================================

 Program:   wxMaracas
 Module:    $RCSfile: marContourVO.cpp,v $
 Language:  C++
 Date:      $Date: 2009/05/14 13:55:07 $
 Version:   $Revision: 1.1 $
 
  Copyright: (c) 2002, 2003
  License:
  
   This software is distributed WITHOUT ANY WARRANTY; without even 
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
   PURPOSE.  See the above copyright notice for more information.
   
=========================================================================*/

#include "marContourVO.h"

// ----------------------------------------------------------------------------
marContour* marContourVO::getContour( ) {
	return _contours;
}

// ----------------------------------------------------------------------------
void marContourVO::setContour(marContour* cont) {
	_contours = cont;
}

// ----------------------------------------------------------------------------
vtkPoints* marContourVO::get3DContour( ) {
	return _3Dcontour;
}

// ----------------------------------------------------------------------------
void marContourVO::set3DContour(vtkPoints* cont) {
	_3Dcontour = cont;
}

// ----------------------------------------------------------------------------
vtkPolyData* marContourVO::get2DContour( ) {
	return _2Dcontours;
}

// ----------------------------------------------------------------------------
void marContourVO::set2DContour(vtkPolyData* cont) {
	_2Dcontours = cont;
}

// ----------------------------------------------------------------------------
vtkPoints* marContourVO::get2DDiameterMin( ) {
	return _2DDiameterMin;
}

// ----------------------------------------------------------------------------
void marContourVO::set2DDiameterMin(vtkPoints* diam) {
	_2DDiameterMin = diam;
}

// ----------------------------------------------------------------------------
vtkPoints* marContourVO::get2DDiameterMax( ) {
	return _2DDiameterMax;
}

// ----------------------------------------------------------------------------
void marContourVO::set2DDiameterMax(vtkPoints* diam) {
	_2DDiameterMax = diam;
}

// ----------------------------------------------------------------------------
double marContourVO::getSignal( ) {
	return _signal;
}

// ----------------------------------------------------------------------------
void marContourVO::setSignal(double signal) {
	_signal = signal;

}	  			

// ----------------------------------------------------------------------------
int marContourVO::getType( ) {
	return _contType;
}

// ----------------------------------------------------------------------------
void marContourVO::setType(int cont) {
	_contType = cont;
}

// ----------------------------------------------------------------------------
vtkContourFilter* marContourVO::getIsocontour()
{
	return _isocontour;
}

// ----------------------------------------------------------------------------
void marContourVO::setIsocontour(vtkContourFilter* iso)
{
	_isocontour = iso;
}

// ----------------------------------------------------------------------------
vtkCleanPolyData* marContourVO::getIsocontourCpd()
{
	return _isocontour_cpd;
}

// ----------------------------------------------------------------------------
void marContourVO::setIsocontourCpd(vtkCleanPolyData* isocpd)
{
	_isocontour_cpd = isocpd;
}

// ----------------------------------------------------------------------------
vtkCleanPolyData* marContourVO::getIsocontourCpd2()
{
	return _isocontour_cpd2;
}


// ----------------------------------------------------------------------------
void marContourVO::setIsocontourCpd2(vtkCleanPolyData* isocpd)
{
	_isocontour_cpd2 = isocpd;
}

// ----------------------------------------------------------------------------
vtkPolyDataConnectivityFilter* marContourVO::getIsocontourDcf()
{
	return _isocontour_dcf;
}

// ----------------------------------------------------------------------------
void marContourVO::setIsocontourDcf(vtkPolyDataConnectivityFilter*	isodcf)
{
	_isocontour_dcf = isodcf;
}

// ----------------------------------------------------------------------------
vtkStripper* marContourVO::getIsocontourStripped()
{
	return _isocontour_stripped;
}

// ----------------------------------------------------------------------------
void marContourVO::setIsocontourStripped(vtkStripper* isoStripped)
{
	_isocontour_stripped = isoStripped;
}

// ----------------------------------------------------------------------------
marContourVO::~marContourVO()
{
	if (_contours != NULL) { delete _contours; }
	if (_3Dcontour != NULL) { _3Dcontour->Delete(); }
	if (_2Dcontours != NULL) { _2Dcontours->Delete(); }
	if (_2DDiameterMin != NULL) { _2DDiameterMin->Delete(); }
	if (_2DDiameterMax != NULL) { _2DDiameterMax->Delete(); }
	_signal = 0.0;
	_contType = -1;
	if (_isocontour != NULL) { _isocontour->Delete(); }
	if (_isocontour_cpd != NULL) { _isocontour_cpd->Delete(); }
	if (_isocontour_dcf != NULL) { _isocontour_dcf->Delete(); }
	if (_isocontour_cpd2 != NULL) { _isocontour_cpd2->Delete(); }
}

// ----------------------------------------------------------------------------
bool marContourVO::isReplaced()
{
	return _replaced;
}

// ----------------------------------------------------------------------------
void marContourVO::setReplaced(bool rep)
{
	_replaced = rep;
}

marContourVO::marContourVO()
{
	_replaced = false;
}
