/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marInterface.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:55:08 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#ifndef __MAR__KERNEL__INTERFACE__HXX__
#define __MAR__KERNEL__INTERFACE__HXX__

//#include "marDicom.h"
#include "marDicomBase.h"
#include "marKVolume.h"
#include "marExperiment.h"

class MAR_KERNEL_EXPORT marInterface
{
  public:

    marInterface( );
    ~marInterface( );

    bool loadParameters( std::string pFile );
    bool saveParameters( std::string pFile );

    bool loadParameters( ) {return loadParameters(m_paramFileName);}
    bool saveParameters( ) {return saveParameters(m_paramFileName);}

    bool initExperiment( );

    bool saveExperiment( std::string nFile );
//    bool loadExperiment( wxString nFile );
    bool loadExperiment( std::string nFile );

    void reset( );

	void		SetParamFileName(std::string pFileName); 
	std::string GetParamFileName();
	void		SetDicom(marFilesBase *dicom);

//EED    void SetVolumeData(int dimX,int dimY,int dimZ, float spacingX, float spacingY, float spacingZ, unsigned short * pixels);
//		marDicom*		_dicom;
//EED   marGdcmDicom*	_dicom;

    marFilesBase*		_dicom;

    marExperiment*	_experiment;
    marParameters*	_parameters;

protected:
	std::string m_paramFileName;
};

#endif // __MAR__KERNEL__INTERFACE__HXX__
