/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marIsocontour.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:55:08 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#ifndef __MAR__KERNEL__ISOCONTOUR__HXX__
#define __MAR__KERNEL__ISOCONTOUR__HXX__

#include "marPoint.h"
#include <vector>

class MAR_KERNEL_EXPORT  marIsocontour
{
public:
	marIsocontour();
	marIsocontour(double intmax);
	virtual ~marIsocontour();

	void getCG(double *x, double *y);
	void insertPoint(double x, double y);
	void getPoint(int i, double *x, double *y);
	void setPoint(int i, double x, double y);
	int getSize();
	double getMaxIntensity();
	void setMaxIntensity(double intmax);
	int getType();
	void setType(int type);
	int getDir(int i);
	void setDir(int i, int direction);
	void setInside(int i, bool ins);
	bool getInside(int i);
	void removeLastPoint();
	

private:
	std::vector<marPoint *> listContour;
	double intmax;
	int type;
};

#endif // __MAR__KERNEL__ISOCONTOUR__HXX__
