

#ifndef __VTK__VTK__OTSU__H__
#define __VTK__VTK__OTSU__H__


#include "vtkImageData.h"

class vtkOtsu
{
public:
	vtkOtsu();
	virtual ~vtkOtsu();
	double calculateOptimalThreshold(vtkImageData *volume, vtkImageData *region);
private:
	double getCriteria(double threshold);
	
	int voxelCount;
	int* histogram;
	double* criterias;
	
	vtkImageData *volume;
	vtkImageData *region;

	double sigmaT;
	double max;

};



#endif // __VTK__VTK__OTSU__H__